import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.io.*;

class Main extends Frame {
    // UnsupportedFlavorException Example
    public static void main(String[] args) {
        // Retrieve handle to clipboard and contents.
        Clipboard clipboard = 
            Toolkit.getDefaultToolkit().getSystemClipboard();
        Transferable t = clipboard.getContents(null);

        if (t == null) {
            // The clipboard is empty
            System.exit(0);
        }
        try {
            t.getTransferData(new DataFlavor("chocolate", "chocolate"));
        } catch (UnsupportedFlavorException e) {
            System.out.println("This transferable object does not "
                +"support the "+e.getMessage() +" data flavor.");
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("The transferable data is "
                +"no longer available.");
        }
    }
}
