import java.awt.*;
import java.awt.event.*;
import java.util.*;

class Main extends Frame implements ComponentListener {
    Dimension screenSize;
    Vector watched = new Vector();

    Main() {
        super("ContainerListener Example");
    
        screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        System.out.println(screenSize);
        setSize(200, 200);
        show();
    }

    public void watch(Component c) {
        watched.addElement(c);
        c.addComponentListener(this);
    }

    public void paint(Graphics g) {
        Insets insets = getInsets();
        int w = getSize().width - insets.left - insets.right;
        int h = getSize().height - insets.top - insets.bottom;

        for (int i=0; i<watched.size(); i++) {
            Component c = (Component)watched.elementAt(i);
            Rectangle r = c.getBounds();
            
            g.drawRect(
                r.x*w/screenSize.width+insets.left, 
                r.y*h/screenSize.height+insets.top, 
                r.width*w/screenSize.width, 
                r.height*h/screenSize.height);
        }
    }

    // Component event handlers.
    public void componentResized(ComponentEvent evt) {
        repaint();
    }
    public void componentMoved(ComponentEvent evt) {
        repaint();
    }
    public void componentShown(ComponentEvent evt) {
        repaint();
    }
    public void componentHidden(ComponentEvent evt) {
        repaint();
    }

    public static void main(String[] args) {
        Main m = new Main();
        Frame f;

        m.watch(f = new Frame("Move me around"));
        f.show();
        m.watch(f = new Frame("Move me around"));
        f.show();
    }
}
