import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

class Main extends Frame implements ActionListener {
    CardLayout cardLayout = new CardLayout();
    Panel cardCont = new Panel(cardLayout);
    Button status;
    Main() {
        super("CardLayout Gaps Example");

        cardCont.add(makeComponent("First"), "First"); 
        cardCont.add(makeComponent("Second"), "Second"); 
        cardCont.add(makeComponent("Third"), "Third"); 
        cardCont.add(makeComponent("Show"), "Show"); 
        cardCont.add(makeComponent("Last"), "Last"); 
        add(cardCont, BorderLayout.CENTER); 
        cardCont.setBackground(Color.red);

        // Create card layout control buttons 
        Panel p = new Panel(new GridLayout(1, 0));
        Button button;
        p.add(button = new Button("First"));
        button.addActionListener(this);
        p.add(button = new Button("Next"));
        button.addActionListener(this);
        p.add(button = new Button("Prev"));
        button.addActionListener(this);
        p.add(button = new Button("Last"));
        button.addActionListener(this);
        p.add(button = new Button("Show"));
        button.addActionListener(this);

        // Add row of buttons to bottom
        add(p, BorderLayout.SOUTH);

        // Create card layout control buttons 
        p = new Panel(new GridLayout(1, 0));
        ActionListener gapHandler = new GapActionHandler();
        p.add(button = new Button("V+"));
        button.addActionListener(gapHandler);
        p.add(button = new Button("V-"));
        button.addActionListener(gapHandler);
        p.add(button = new Button("H+"));
        button.addActionListener(gapHandler);
        p.add(button = new Button("H-"));
        button.addActionListener(gapHandler);
        status = new Button("Vgap="+cardLayout.getVgap() + 
                            ", Hgap="+cardLayout.getHgap());
        p.add(status);

        // Add gap control buttons to top
        add(p, BorderLayout.NORTH);

        pack();
        show();
    }

    public Component makeComponent(String label) {
        Label l = new Label(label, Label.CENTER);
        l.setBackground(Color.blue);
        l.setForeground(Color.white);
        return l;
    }

    public void actionPerformed(ActionEvent evt) {
        String cmd = evt.getActionCommand();
        if ("First".equals(cmd)) {
            cardLayout.first(cardCont);
        } else if ("Prev".equals(cmd)) {
            cardLayout.previous(cardCont);
        } else if ("Next".equals(cmd)) {
            cardLayout.next(cardCont);
        } else if ("Last".equals(cmd)) {
            cardLayout.last(cardCont);
        } else if ("Show".equals(cmd)) {
            cardLayout.show(cardCont, cmd);
        } 
    }

    class GapActionHandler implements ActionListener {
        public void actionPerformed(ActionEvent evt) {
            String what = evt.getActionCommand();
            
            if ("H+".equals(what)) {
                cardLayout.setHgap(cardLayout.getHgap()+5);
            } else if ("H-".equals(what)) {
                cardLayout.setHgap(Math.max(0, cardLayout.getHgap()-5));
            } else if ("V+".equals(what)) {
                cardLayout.setVgap(cardLayout.getVgap()+5);
            } else if ("V-".equals(what)) {
                cardLayout.setVgap(Math.max(0, cardLayout.getVgap()-5));
            }
            // Update status button
            status.setLabel("Vgap="+cardLayout.getVgap() +
                            ", Hgap="+cardLayout.getHgap());
            cardCont.invalidate();
            cardCont.validate();
        }
    }

    public static void main(String args[]) {
        new Main();
    }
}
