import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Main () {
        super("isFocusTraversable example");

        // Create components that are focus traversable by default.
        add(new TextField("TextField1"), BorderLayout.NORTH);
        add(new TextField("TextField2"), BorderLayout.SOUTH);

        // Create focus traversable 
        add(new FocusCanvas(200, 100), BorderLayout.CENTER);

        setSize(200, 200);
        pack();
        show();
    }

    public static void main(String[] args) {
        new Main();
    }
}

class FocusCanvas extends Canvas {
    boolean hasFocus = false;
    FocusCanvas(int x, int y) {
        super();
        setSize(x, y);

        // Listen for events.
        addMouseListener(new MouseEventHandler());
        addFocusListener(new FocusEventHandler());
    }

    // Implement focus traversable.
    public boolean isFocusTraversable() {
        return true;
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            requestFocus();
        }
    }

    // Change background color to blue when focus is gained.
    class FocusEventHandler extends FocusAdapter {
        public void focusGained(FocusEvent evt) {
            hasFocus = true;
            repaint();
        }
        public void focusLost(FocusEvent evt) {
            hasFocus = false;
            repaint();
        }
    }

    public void paint(Graphics g) {
        if (hasFocus) {
            setBackground(Color.blue);
        } else {
            setBackground(Color.white);
        }
    }
}
