import java.awt.*;
class Main extends Frame {
    int[] styles = {
        Font.PLAIN, Font.ITALIC, Font.BOLD, Font.BOLD|Font.ITALIC};
    String[] styleNames = {
        "plain", "italic", "bold", "bold-italic", "plain-bold-italic"};

    Main() {
        super("Font Example");

        setSize(300, 400);
        show();
    }

    public void paint(Graphics g) {
        int y = 5;

        String[] fontNames = Toolkit.getDefaultToolkit().getFontList();
        for (int i=0; i<fontNames.length; i++) {
            for (int j=0; j<styles.length; j++) {
                Font f = new Font(fontNames[i], styles[j], 13);
                FontMetrics fm = g.getFontMetrics(f);

                y += fm.getAscent();
                g.setFont(f);
                g.drawString(fontNames[i]+" "+styleNames[j]
                    +" ("+f.getFamily()+")", 5, y);
                y += fm.getLeading();
            }
            y += 13;
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
