import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    // The contructor creates a frame with a window size that gives
    // the desired interior size.
    Main() {
        super("Frame Example");
        // Calling addNotify() creates the peers; otherwise insets()
        // does not return the right values.
        addNotify();

        Insets insets = getInsets();
        setSize(insets.left + insets.right + 150,  
                insets.top + insets.bottom + 150);

        // Add listener
        this.addMouseListener(new MouseEventHandler());

    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            // x, y are in interior coordinates 
            // must be translated to screen coordinates.
            Rectangle bounds = getBounds();
            int x = evt.getX() + bounds.x;
            int y = evt.getY() + bounds.y;

            // Set location of new frame
            Main m = new Main();
            m.setLocation(x, y);
            m.show();
        }
    }

    static public void main(String[] args) {
        (new Main()).show();
    }
}

