import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    Button btnCreate = new Button("Create Frame");
    Button btnDispose = new Button("Dispose Frame");
    Frame f;

    Main() {
        super("dispose Example");

        btnDispose.setEnabled(true);
        add(btnCreate, BorderLayout.NORTH); 
        add(btnDispose, BorderLayout.SOUTH); 

        // Add Listeners
        btnDispose.addActionListener(this);
        btnCreate.addActionListener(this);
        this.addWindowListener(new WindowEventHandler());

        setSize(100, 100);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource() == btnCreate) {
            btnCreate.setEnabled(false);
            btnDispose.setEnabled(true);
            f = new Frame("New Frame");
            f.setBounds(100, 100, 100, 100);
            f.show();
        } else if (evt.getSource() == btnDispose) {
            btnCreate.setEnabled(true);
            btnDispose.setEnabled(false);
            f.dispose();
        }
    }

    class WindowEventHandler extends WindowAdapter {
        public void windowClosing(WindowEvent evt) {
            dispose();
        }
    }
            
    static public void main(String[] args) {
        new Main();
    }
}
