import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    boolean showIconImage = false;

    Main(String filename) {
        super("setIconImage Example");
        try {
            Image image = getToolkit().getImage(filename);
            setIconImage(image);
        } catch (Exception e) {
            e.printStackTrace();
        }

        Button b;
        add(b = new Button("Icon Image"), BorderLayout.SOUTH);
        b.addActionListener(this);

        setSize(50, 150);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        showIconImage = !showIconImage;
        repaint();
    }

    public void paint(Graphics g) {
        if (showIconImage) {
            Insets insets = getInsets();
            g.drawImage(getIconImage(), insets.left, insets.top, this);
        }
    }

    static public void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("usage: java Main <image file>");
        }
    }
}

