import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ItemListener {
    Panel panel = new Panel();

    MainCanvas cv = new MainCanvas();
    Canvas overlap = new Canvas();
    Checkbox cb = new Checkbox("Overlap", null, false);

    Main() {
        super("copyArea Example");
        panel.setLayout(new BorderLayout());
        panel.add(cv, BorderLayout.CENTER);

        add(overlap);
        add(panel);
        add(cb);
	cb.addItemListener(this);

        overlap.setBackground(Color.green);
        overlap.setVisible(false);
        setSize(400, 100);
        show();
    }

    // In order to get the overlapping window to overlap another, 
    // we need to implement our own specific layout.  
    public synchronized void doLayout() {
        Insets insets = this.getInsets();
        Dimension d = cb.getPreferredSize();
        int w = getSize().width - insets.left-insets.right;
        int h = getSize().height - insets.top-insets.bottom;

        panel.setBounds(insets.left, insets.top, w, h-d.height);
        cb.setBounds(insets.left, getSize().height-insets.bottom-d.height, 
		     w, d.height);
        overlap.setBounds(insets.left, insets.top, 1, h);
    }

    public void itemStateChanged(ItemEvent evt) {
	overlap.setVisible(cb.getState());
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas implements Runnable {
    MainCanvas() {
        (new Thread(this)).start();
    }

    //  Returns an integer in the range [0..r-1].
    int random(int r) {
        return (int)(Math.floor(Math.random()*r));
    }

    public void update(Graphics g) {
        int w = getSize().width;
        int h = getSize().height;

        // shift right by 1 pixel.
        g.copyArea(0, 0, w-1, h, 1, 0);
        g.clearRect(0, 0, 1, h);
        g.drawLine(0, random(h), 0, h);
    }

    public void paint(Graphics g) {
        int w = getSize().width;
        int h = getSize().height;
        Rectangle r = g.getClipBounds();

        if (r == null || (r.width == w && r.height == h)) {
            g.setColor(Color.blue); // full repaint
        } else {
            g.setColor(Color.red); // partial repaint
        }
        g.fillRect(0, random(h), w, h);
    }

    public void run() {
        while (true) {
            try {Thread.sleep(100);} catch (Exception e) {};
            repaint();
        }
    }
}
