import java.awt.*;
import java.awt.event.*;
import java.util.*;

class Main extends Frame {
    Main() {
        super("drawRect Example");
        add(new MainCanvas(), BorderLayout.CENTER); 

        setSize(200, 200);
        show();
    }
    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    Vector rects = new Vector();
    int startX, startY;
    Rectangle oldRect, newRect;

    MainCanvas() {
        addMouseListener(new MouseEventHandler());
        addMouseMotionListener(new MouseMotionEventHandler());
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        // First erase old rect.
        if (oldRect != null) {
            g.setXORMode(Color.white);
            g.drawRect(oldRect.x, oldRect.y, oldRect.width, oldRect.height);
            g.setPaintMode();
        }
        // Now paint rectangles.
        for (int i=0; i<rects.size(); i++) {
            Rectangle r = (Rectangle)rects.elementAt(i);
            g.drawRect(r.x, r.y, r.width, r.height);
        }
        if (newRect != null) {
            g.setXORMode(Color.white);
            g.drawRect(newRect.x, newRect.y, newRect.width, newRect.height);
            g.setPaintMode();
        }
        oldRect = newRect;
        newRect = null;
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            int x = evt.getX(), y = evt.getY();
            startX = x;
            startY = y;
            newRect = new Rectangle(x, y, 1, 1);
            repaint();
        }
        public void mouseReleased(MouseEvent evt) {
            int x = evt.getX(), y = evt.getY();
            rects.addElement(new Rectangle(startX, startY, 
                                           x-startX, y-startY));
            newRect = null;
            repaint();
        }
    }

    class MouseMotionEventHandler extends MouseMotionAdapter {
        public void mouseDragged(MouseEvent evt) {
            int x = evt.getX(), y = evt.getY();
            newRect = new Rectangle(startX, startY, x-startX, y-startY);
            repaint();
        }
    }
}
