import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    String[] figureNames = {"circle", "oval", "square", "rectangle"};
    String[] colorNames = {"red", "green", "blue", "yellow"};
    Color[] colorValues = {Color.red, Color.green, 
                           Color.blue, Color.yellow};
    Choice chFigure = new Choice();
    Choice chColor = new Choice();
    int curX, curY;

    Main() {
        super("fillRect Example");
        Panel p = new Panel(new GridLayout(1, 0));

        for (int i=0; i<figureNames.length; i++) {
            chFigure.addItem(figureNames[i]);
        }
        for (int i=0; i<colorNames.length; i++) {
            chColor.addItem(colorNames[i]);
        }
        p.add(chColor);
        p.add(chFigure);
        add(p, BorderLayout.NORTH); 

        addMouseListener(new MouseEventListener());

        setSize(300, 300);
        show();
    }

    public void update(Graphics g) {
        g.setColor(colorValues[chColor.getSelectedIndex()]);
        switch (chFigure.getSelectedIndex()) {
        case 0: // circle
            g.fillOval(curX, curY, 30, 30);
            break;
        case 1: // oval
            g.fillOval(curX, curY, 30, 50);
            break;
        case 2: // square
            g.fillRect(curX, curY, 30, 30);
            break;
        case 3: // rectangle
            g.fillRect(curX, curY, 30, 50);
            break;
        }
    }

    class MouseEventListener extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            curX = evt.getX();
            curY = evt.getY();
            repaint();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
