import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    GridBagLayout gbl = new GridBagLayout();
    Point free = new Point(2, 2);

    Main() {
        super("gridx Example");
        Component c = null;

        setLayout(gbl);
        for (int i=0; i<3; i++) {
            for (int j=0; j<3; j++) {
                c = makeButton(String.valueOf((char)('1'+i+3*j)), i, j);
            }
        }
        remove(c);       // remove the last button
        setSize(200, 200);
        show();
    }

    // Returns the new button.
    Component makeButton(String label, int x, int y) {
        GridBagConstraints c = new GridBagConstraints();
        Button b = new Button(label);

        c.gridx = x;
        c.gridy = y;
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;
        c.weighty = 1;
        gbl.setConstraints(b, c);
        add(b);
        b.addActionListener(this);
        return b;
    }

    public void actionPerformed(ActionEvent evt) {
        Button button = (Button)evt.getSource();
        GridBagConstraints gbc = gbl.getConstraints(button);
        Point p = new Point(gbc.gridx, gbc.gridy);

        if ((p.x == free.x && Math.abs(p.y-free.y) == 1) 
                || (p.y == free.y && Math.abs(p.x-free.x) == 1)) {
            gbc.gridx = free.x;
            gbc.gridy = free.y;
            gbl.setConstraints(button, gbc);
            free = p;
            invalidate();
            validate();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
