import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    GridBagLayout gbl = new GridBagLayout();

    Main() {
        super("getLayoutWeights Example");
        setLayout(gbl);
        printLayoutData(gbl);

        makeButton(0, 0);
        makeButton(0, 1);
        makeButton(1, 0);
        makeButton(1, 1);
        setSize(200, 200);
        show();
    }

    void printLayoutData(GridBagLayout gbl) {
        System.out.println("====================================");
        // print layout weights
        System.out.println("Layout Weights");
        System.out.println("--------------");
        double[][]weights = gbl.getLayoutWeights();
        System.out.print("    "+weights[0].length+" columns: ");
        for (int i=0; i<weights[0].length; i++)  {
            System.out.print(weights[0][i]+" ");
        }
        System.out.println();
        System.out.print("    "+weights[1].length+" rows: ");
        for (int i=0; i<weights[1].length; i++) {
            System.out.print(weights[1][i]+" ");
        }

        // print layout dimensions
        System.out.println();
        System.out.println("Layout Dimensions");
        System.out.println("-----------------");
        int[][]dims = gbl.getLayoutDimensions();
        System.out.print("    "+dims[0].length+" columns: ");
        for (int i=0; i<dims[0].length; i++) {
            System.out.print(dims[0][i]+" ");
        }
        System.out.println();
        System.out.print("    "+dims[1].length+" rows: ");
        for (int i=0; i<dims[1].length; i++) {
            System.out.print(dims[1][i]+" ");
        }
        System.out.println();
    }
        
    void makeButton(int x, int y) {
        GridBagConstraints c = new GridBagConstraints();
        Button b = new Button("(0,0)");

        add(b);
        c.fill = GridBagConstraints.BOTH;
        c.gridx = x;
        c.gridy = y;
        gbl.setConstraints(b, c);
        b.addActionListener(this);
    }

    public void actionPerformed(ActionEvent evt) {
        Button b = (Button)evt.getSource();
        GridBagConstraints c = gbl.getConstraints(b);

        if (c.weightx == 0 && c.weighty == 0) {
            c.weighty = 1;
        } else if (c.weightx == 0 && c.weighty == 1) {
            c.weightx = 1;
        } else if (c.weightx == 1 && c.weighty == 1) {
            c.weighty = 0;
        } else {
            c.weightx = 0;
        }
        b.setLabel("("+c.weightx+","+c.weighty+")");
        gbl.setConstraints(b, c);
        invalidate();
        validate();
        printLayoutData(gbl);
    }

    static public void main(String[] args) {
        new Main();
    }
}
