import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Insets rectInsets = new Insets(0, 0, 0, 0);

    Main() {
        super("Insets Example");
        setSize(150, 150);
        addKeyListener(new KeyEventHandler());
        show();
    }

    public void paint(Graphics g) {
        Insets frameInsets = getInsets();
        int x = frameInsets.left, y = frameInsets.top;

        int w = getSize().width - frameInsets.right-frameInsets.left;
        int h = getSize().height - frameInsets.bottom-frameInsets.top;
        FontMetrics fm = g.getFontMetrics();
        
        g.fillRect(x+rectInsets.left, y+rectInsets.top, 
            w - rectInsets.right - rectInsets.left,
            h - rectInsets.bottom - rectInsets.top);
        g.setColor(Color.white);
        // top
        g.drawString("top", x + rectInsets.left 
                + (w-rectInsets.left-rectInsets.right-fm.stringWidth("top"))/2, 
            y + rectInsets.top+fm.getAscent());
        // left
        g.drawString("left", x+ rectInsets.left, 
                y+rectInsets.top + (h-rectInsets.top-rectInsets.bottom-fm.getHeight())/2);
        // bottom
        g.drawString("bottom", x+rectInsets.left 
                + (w-rectInsets.left-rectInsets.right-fm.stringWidth("bottom"))/2, 
            y+h-rectInsets.bottom-fm.getDescent());
        // right
        g.drawString("right", x+w-rectInsets.right-fm.stringWidth("right"), 
                y+rectInsets.top + (h-rectInsets.top-rectInsets.bottom-fm.getHeight())/2);
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyTyped(KeyEvent evt) {
            char key = evt.getKeyChar();
            key = Character.toLowerCase(key);
            switch (key) {
            case 't':
                if (evt.isShiftDown()) {
                    if (rectInsets.top > 0) {
                        rectInsets.top--;
                    }
                } else {
                    rectInsets.top++;
                }
                break;
            case 'b':
                if (evt.isShiftDown()) {
                    if (rectInsets.bottom > 0) {
                        rectInsets.bottom--;
                    }
                } else {
                    rectInsets.bottom++;
                }
                break;
            case 'l':
                if (evt.isShiftDown()) {
                    if (rectInsets.left > 0) {
                        rectInsets.left--;
                    }
                } else {
                    rectInsets.left++;
                }
                break;
            case 'r':
                if (evt.isShiftDown()) {
                    if (rectInsets.right > 0) {
                        rectInsets.right--;
                    }
                } else {
                    rectInsets.right++;
                }
            }
            repaint();
        }
    }

    public static void main(String[] args) {
        new Main();
    }
}
