import java.awt.*;
import java.awt.event.*;
import java.util.*;

class Main extends Frame implements ActionListener {
    Vector commands = new Vector();
    Menu m = new Menu("Commands");

    Main() {
        super("Menu Example");
        MenuBar mb = new MenuBar();

        // Add menu to menu bar.
        mb.add(m);

        // Set the menu bar on the frame.
        setMenuBar(mb);
        TextField tf = new TextField();
        add(tf, BorderLayout.SOUTH);
        tf.addActionListener(this);

        setSize(100, 100);    
        show();
    }

    void updateMenu(Menu m) {
        // First remove all the menu items.
        m.removeAll();

        // Then add them back in.
        for (int i=0; i<commands.size(); i++) {
            m.add((String)commands.elementAt(i));
        }
    }

    public void addCommand(String cmd) {
        for (int i=0; i<m.getItemCount(); i++) {
            MenuItem mi = (MenuItem)m.getItem(i);
            if (mi.getLabel().equals(cmd)) {
                // Move command to top of list.
                commands.removeElementAt(i);
                commands.insertElementAt(cmd, 0);
                updateMenu(m);
                return;
            }
        }
        if (m.getItemCount() >= 10) {
            // Remove last command from list.
            commands.removeElementAt(commands.size()-1);
        }
        commands.insertElementAt(cmd, 0);
        updateMenu(m);
    }

    // Action handler for text field
    public void actionPerformed(ActionEvent evt) {
        String what = evt.getActionCommand();
        if (!what.equals("")) {
            addCommand(what);
            ((TextField)evt.getSource()).setText("");
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
