import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener, AdjustmentListener {
    Scrollbar scrollbar = new Scrollbar(Scrollbar.VERTICAL, 0, 10, 10, 100);
    Label max, min, vis, posn;

    Main() {
        super("Scrollbar.setMinimum");
        Panel p = new Panel(new GridLayout(4, 0));

        max = new Label("Max=" + scrollbar.getMaximum());
        p.add(max);

        Button b = new Button("Max -5");
        p.add(b);
        b.addActionListener(this);
        b = new Button("Max +5");
        p.add(b);
        b.addActionListener(this);

        min = new Label("Min=" + scrollbar.getMinimum());
        p.add(min);
        b = new Button("Min -5");
        p.add(b);
        b.addActionListener(this);
        b = new Button("Min +5");
        p.add(b);
        b.addActionListener(this);

        vis = new Label("Vis=" + scrollbar.getVisibleAmount());
        p.add(vis);
        b = new Button("Vis -5");
        p.add(b);
        b.addActionListener(this);
        b = new Button("Vis +5");
        p.add(b);
        b.addActionListener(this);

        posn = new Label("vertical");
        p.add(posn);
        b = new Button("Vertical");
        p.add(b);
        b.addActionListener(this);
        b = new Button("Horizontal");
        p.add(b);
        b.addActionListener(this);

        add(p, BorderLayout.SOUTH);
        add(scrollbar, BorderLayout.EAST);

        scrollbar.addAdjustmentListener(this);
        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        String cmd = evt.getActionCommand();
        if (cmd.equals("Max -5")) {
            scrollbar.setMaximum(scrollbar.getMaximum()-5);
            max.setText("Max=" + scrollbar.getMaximum());
        } else if (cmd.equals("Max +5")) {
            scrollbar.setMaximum(scrollbar.getMaximum()+5);
            max.setText("Max=" + scrollbar.getMaximum());
        } else  if (cmd.equals("Min -5")) {
            scrollbar.setMinimum(scrollbar.getMinimum()-5);
            min.setText("Min=" + scrollbar.getMinimum());
        } else if (cmd.equals("Min +5")) {
            scrollbar.setMinimum(scrollbar.getMinimum()+5);
            min.setText("Min=" + scrollbar.getMinimum());
        } else  if (cmd.equals("Vis -5")) {
            scrollbar.setVisibleAmount(scrollbar.getVisibleAmount()-5);
            vis.setText("vis=" + scrollbar.getVisibleAmount());
        } else if (cmd.equals("Vis +5")) {
            scrollbar.setVisibleAmount(scrollbar.getVisibleAmount()+5);
            vis.setText("vis=" + scrollbar.getVisibleAmount());
        } else  if (cmd.equals("Horizontal")) {
            if (scrollbar.getOrientation() != Scrollbar.HORIZONTAL) {
                scrollbar.setOrientation(Scrollbar.HORIZONTAL);
                posn.setText("horizontal");
                remove(scrollbar);
                add(scrollbar, BorderLayout.NORTH);
                validate();
            }
        } else if (cmd.equals("Vertical")) {
            if (scrollbar.getOrientation() != Scrollbar.VERTICAL) {
                scrollbar.setOrientation(Scrollbar.VERTICAL);
                posn.setText("vertical");
                remove(scrollbar);
                add(scrollbar, BorderLayout.EAST);
                validate();
            }
        }
    }

    public void adjustmentValueChanged(AdjustmentEvent evt) {
        System.out.println("value = " + scrollbar.getValue() + 
                           " visible = " + scrollbar.getVisibleAmount() +
                           " min = " + scrollbar.getMinimum() + 
                           " max = " + scrollbar.getMaximum());
    }

    public static void main(String[] args) {
        new Main();
    }
}
