import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements TextListener {
    Main () {
        super("getScrollbarVisibility Example");
        Panel p = 
            new Panel(new GridLayout(2, 2));
        TextArea both = new TextArea("Both horizontal and vertical",
                                     10, 10, TextArea.SCROLLBARS_BOTH);
        TextArea hor = new TextArea("Horizontal only",
                                    10, 10, TextArea.SCROLLBARS_HORIZONTAL_ONLY);
        TextArea ver = new TextArea("Vertical only",
                                    10, 10, TextArea.SCROLLBARS_VERTICAL_ONLY);
        TextArea none = new TextArea("No horizontal or vertical",
                                     10, 10, TextArea.SCROLLBARS_NONE);

        p.add(both);
        p.add(hor);
        p.add(ver);
        p.add(none);
        both.addTextListener(this);
        hor.addTextListener(this);
        ver.addTextListener(this);
        none.addTextListener(this);

        add(p);
        pack();
        show();
    }

    public void textValueChanged(TextEvent evt) {
        TextArea src = (TextArea)evt.getSource();
        switch (src.getScrollbarVisibility()) {
        case TextArea.SCROLLBARS_BOTH:
            System.out.println("both");
            break;
        case TextArea.SCROLLBARS_HORIZONTAL_ONLY:
            System.out.println("horizontal only");
            break;
        case TextArea.SCROLLBARS_VERTICAL_ONLY:
            System.out.println("vertical only");
            break;
        case TextArea.SCROLLBARS_NONE:
            System.out.println("none");
            break;
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
