import java.awt.*;

class Main extends Frame {
    Main() {
        super("Toolkit Example");
        Dimension d;
        d = Toolkit.getDefaultToolkit().getScreenSize();

        setSize(225, 100);
        setLocation((d.width-getBounds().width)/2, 
                    (d.height-getBounds().height)/2);
        show();
    }

    public void paint(Graphics g) {
        FontMetrics fm = g.getFontMetrics();
        int resol = Toolkit.getDefaultToolkit().getScreenResolution();
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        Insets insets = getInsets();
        int x = insets.left;
        int y = insets.top + fm.getAscent();

        g.drawString("screen resolution = "+resol, x, y);
        y += fm.getHeight();
        g.drawString("screen width = " 
            + ((double)d.width/resol) + " \"", x, y);
        y += fm.getHeight();
        g.drawString("screen height = " 
            + ((double)d.height/resol) + " \"", x, y);
    }

    public static void main(String[] args) {
        new Main();
    }
}
