import java.beans.*;
import java.lang.reflect.*;

public class BeanBeanInfo extends SimpleBeanInfo {
    public PropertyDescriptor[] getPropertyDescriptors() {
        IndexedPropertyDescriptor pd[] = new IndexedPropertyDescriptor[3];

        try {
          // The getter and setter methods are derived from the property name.
            pd[0] = new IndexedPropertyDescriptor("property1", Bean.class);

          // The names of the getter and setter methods are supplied.
            pd[1] = new IndexedPropertyDescriptor("property2", Bean.class,
                "getProperty2", "setProperty2", "getProperty2", "setProperty2");

          // The Method objects of the getter and setter methods are supplied.

            // The getter method must not take any parameters.
            Class[] getArgs = {};
            Method getter = Bean.class.getMethod("getProperty3", getArgs);

            // The indexedGetter method takes one integer parameter.
            Class[] igetArgs = {Integer.TYPE};
            Method indexedGetter = 
                Bean.class.getMethod("getProperty3", igetArgs);

            // The setter must take one parameter and it must have the
            // same type as returned by the getter method.
            Class[] setArgs = {getter.getReturnType()};
            Method setter = Bean.class.getMethod("setProperty3", setArgs);

            // The indexedSetter must take two parameters - an integer and
            // an object of the same type as returned by the 
            // indexed getter method.
            Class[] isetArgs = {Integer.TYPE, indexedGetter.getReturnType()};
            Method indexedSetter = 
                Bean.class.getMethod("setProperty3", isetArgs);

            pd[2] = new IndexedPropertyDescriptor("property3", getter, setter,
                        indexedGetter, indexedSetter);

            return pd;
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (IntrospectionException e) {
            e.printStackTrace();
        }
        return null;
    }
}
