import java.awt.*;
import java.beans.*;
import java.text.*;
import java.util.*;

public class Bean extends Panel {
    public Date date = new Date();
    public Locale locale = Locale.getDefault();
    public int style = DateFormat.MEDIUM;

    // Use a label to display the current flavor.
    Label l = new Label(toString());

    public Bean() {
        add(l);
    }

    // Date accessor methods.
    public Date getDate() {
        return date;
    }
    public void setDate(Date date) {
        this.date = date;
        l.setText(toString());
    }

    // Format Style accessor methods.
    public int getStyle() {
        return style;
    }
    public void setStyle(int style) {
        this.style = style;
        l.setText(toString());
    }

    // Locale accessor methods.
    public Locale getLocale() {
        return locale;
    }
    public void setLocale(Locale locale) {
        this.locale = locale;
        l.setText(toString());
    }

    // Converts the date into a string using the current locale and style.
    public String toString() {
        return DateFormat.getDateInstance(style, locale).format(date);
    }
}
/* 
    manifest.txt:
        Name: Bean.class
        Java-Bean: True
    jar command:
        jar cfm bean.jar manifest.txt *.class 
*/
 