import java.beans.*;
import java.text.*;
import java.util.*;

public class LocaleEditor extends PropertyEditorSupport {
    Locale[] locales = DateFormat.getAvailableLocales();
    String[] localeNames = new String[locales.length];

    public LocaleEditor() {
        super();
        for (int i=0; i<locales.length; i++) {
            localeNames[i] = locales[i].getDisplayName();
        }
    }
        
    public String[] getTags() {
        return localeNames;
    }

    public String getAsText() {
        return ((Locale)getValue()).getDisplayName();
    }

    public void setAsText(String text) throws IllegalArgumentException {
        for (int i=0; i<locales.length; i++) {
            if (text.equals(localeNames[i])) {
                setValue(locales[i]);
                return;
            }
        }
        throw new IllegalArgumentException(text);
    }
}
